import { Peer, Me } from './peer';
import { Node } from './node';
import { PK, Keypair, Clonable } from '../types';
export declare class Leaf implements Clonable {
    peer: Peer;
    pk: PK;
    sk?: Uint8Array | undefined;
    private constructor();
    clone(): Leaf;
    static me(me: Me, init?: {
        identity_pk: PK;
        exchange_pk: PK;
    }): Leaf;
    static member(member: Peer, init: PK | {
        identity: Keypair;
        exchange: Keypair;
    }): Leaf;
    get length(): number;
    get isOnMyPath(): boolean;
    split(at: PK, peer: Peer, init: PK[] | {
        identity: Keypair;
        exchange: Keypair;
    } | {
        identity_pk: PK;
        exchange_pk: PK;
    }): Node | undefined;
    update(pk: PK): void;
    members(): Generator<Leaf>;
    leafs(): Generator<Leaf>;
}
