import { Clonable, Keypair, PK, SK } from '../types';
import { Leaf } from './leaf';
import { Peer } from './peer';
export declare class Node implements Clonable {
    left: Node | Leaf;
    right: Node | Leaf;
    pk: PK;
    sk?: SK;
    constructor(left: Node | Leaf, right: Node | Leaf, pk?: PK);
    clone(): Node;
    update(pk: PK): void;
    derive(): PK;
    private static derive;
    get length(): number;
    get isOnMyPath(): boolean;
    split(at: PK, peer: Peer, init: PK[] | {
        identity: Keypair;
        exchange: Keypair;
    } | {
        identity_pk: PK;
        exchange_pk: PK;
    }): Node | boolean;
    members(): Generator<Node | Leaf>;
    leafs(): Generator<Leaf>;
    pathOf(peer: Peer): Generator<Node | Leaf>;
}
export type SecretNode = Node & {
    sk: SK;
};
