"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Me = exports.Peer = void 0;
const __1 = require("..");
const err_1 = require("../err");
class Peer {
    constructor(identity_pk, ephemeral_pk, ephemeral_signature) {
        this.identity_pk = identity_pk;
        this.ephemeral_pk = ephemeral_pk;
        this.ephemeral_signature = ephemeral_signature;
        if (!__1.crypt.verify(this.ephemeral_signature, this.ephemeral_pk, this.identity_pk)) {
            throw new err_1.Err(err_1.ErrCode.INVALID_SIGNATURE, 'Invalid ephemeral signature');
        }
    }
    clone() {
        return new Peer(this.identity_pk.slice(), this.ephemeral_pk.slice(), this.ephemeral_signature.slice());
    }
    get isMy() {
        return false;
    }
}
exports.Peer = Peer;
class Me extends Peer {
    constructor(identity, ephemeral) {
        super(identity.pk, ephemeral.pk, __1.crypt.sign(ephemeral.pk, identity.sk));
        this.identity = identity;
        this.ephemeral = ephemeral;
    }
    clone() {
        return new Me({ pk: this.identity.pk.slice(), sk: this.identity.sk.slice() }, { pk: this.ephemeral.pk.slice(), sk: this.ephemeral.sk.slice() });
    }
    get isMy() {
        return true;
    }
}
exports.Me = Me;
