"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Err = exports.ErrCode = void 0;
var ErrCode;
(function (ErrCode) {
    ErrCode["INCONSISTENT_STATE"] = "INCONSISTENT_STATE";
    ErrCode["INVALID_SIGNATURE"] = "INVALID_SIGNATURE";
    ErrCode["ENCODING_ERROR"] = "ENCODING_ERROR";
    ErrCode["INVALID_ARGUMENT"] = "INVALID_ARGUMENT";
})(ErrCode = exports.ErrCode || (exports.ErrCode = {}));
const messages = {
    [ErrCode.INCONSISTENT_STATE]: 'Inconsistent ART state',
    [ErrCode.INVALID_SIGNATURE]: 'Invalid data signature',
    [ErrCode.ENCODING_ERROR]: 'Data encoding error',
    [ErrCode.INVALID_ARGUMENT]: 'Invalid argument error',
};
/**
 * Error class, used throughout the project
 */
class Err extends Error {
    constructor(code, details) {
        super(messages[code] + (details ? ': ' + details : ''));
        this.code = code;
    }
}
exports.Err = Err;
