import { Crypt } from './types';
/**
 * General abstractions used throughout the package
 */
export * from './types';
/**
 * ART & other types
 */
export * from './art/index';
/**
 * Error class & code enum
 */
export * from './err';
/**
 * Handy utilities
 */
export * from './util';
/**
 * Stub to provide your own crypto implementation (tests use @noble/curves/secp256k1)
 * Note that implementation must support both: DH & sign/verify for the same key.
 * secp256k1 supports both out of the box, 25519 would need extra handling.
 */
export declare let crypt: Crypt;
/**
 * Set crypto implementation
 *
 * @param crypto underlying crypto implementaion
 */
export declare function setCrypto(crypto: Crypt): void;
