"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setCrypto = exports.crypt = void 0;
const err_1 = require("./err");
/**
 * General abstractions used throughout the package
 */
__exportStar(require("./types"), exports);
/**
 * ART & other types
 */
__exportStar(require("./art/index"), exports);
/**
 * Error class & code enum
 */
__exportStar(require("./err"), exports);
/**
 * Handy utilities
 */
__exportStar(require("./util"), exports);
/**
 * Stub to provide your own crypto implementation (tests use @noble/curves/secp256k1)
 * Note that implementation must support both: DH & sign/verify for the same key.
 * secp256k1 supports both out of the box, 25519 would need extra handling.
 */
exports.crypt = {
    generateSecretKey: () => {
        throw new err_1.Err(err_1.ErrCode.INCONSISTENT_STATE, 'call setCrypt() before using');
    },
    derivePublicKey: () => {
        throw new err_1.Err(err_1.ErrCode.INCONSISTENT_STATE, 'call setCrypt() before using');
    },
    getSharedSecret: () => {
        throw new err_1.Err(err_1.ErrCode.INCONSISTENT_STATE, 'call setCrypt() before using');
    },
    hash_256: () => {
        throw new err_1.Err(err_1.ErrCode.INCONSISTENT_STATE, 'call setCrypt() before using');
    },
    sign: () => {
        throw new err_1.Err(err_1.ErrCode.INCONSISTENT_STATE, 'call setCrypt() before using');
    },
    verify: () => {
        throw new err_1.Err(err_1.ErrCode.INCONSISTENT_STATE, 'call setCrypt() before using');
    },
    hkdf: () => {
        throw new err_1.Err(err_1.ErrCode.INCONSISTENT_STATE, 'call setCrypt() before using');
    },
    encrypt: () => {
        throw new err_1.Err(err_1.ErrCode.INCONSISTENT_STATE, 'call setCrypt() before using');
    },
    decrypt: () => {
        throw new err_1.Err(err_1.ErrCode.INCONSISTENT_STATE, 'call setCrypt() before using');
    },
    PK_LENGTH: -1,
    SK_LENGTH: -1,
    SI_LENGTH: -1,
    ENCRYPTION_PREFIX_LENGTH: -1,
    ENCRYPTION_SUFFIX_LENGTH: -1,
};
/**
 * Set crypto implementation
 *
 * @param crypto underlying crypto implementaion
 */
function setCrypto(crypto) {
    exports.crypt = crypto;
}
exports.setCrypto = setCrypto;
