"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.referenceGroup = exports.generate = void 0;
const src_1 = require("../src");
function generate(n) {
    return new Array(n).fill(0).map(() => {
        const identity = (0, src_1.keypair)();
        const ephemeral = (0, src_1.keypair)();
        return { identity, ephemeral, ephemeral_signature: src_1.crypt.sign(ephemeral.pk, identity.sk) };
    });
}
exports.generate = generate;
function referenceGroup() {
    const keys = generate(3);
    const art = src_1.ART.initiate(keys.map(({ identity, ephemeral, ephemeral_signature }, i) => i === 0 ? new src_1.Me(identity, ephemeral) : new src_1.Peer(identity.pk, ephemeral.pk, ephemeral_signature)));
    return [art].concat(keys.slice(1).map((keys) => src_1.ART.fromSetupMessage(new src_1.Me(keys.identity, keys.ephemeral), art.setupMessage)));
}
exports.referenceGroup = referenceGroup;
